<template>
  <single-panel>
    <ob-table
      :columns="tmsColumns"
      :functionalPanel="true"
      :remote-opt="{
        method: getTms
      }"
      :tableLayoutFixed="false"
      :showAddButton="true"
      add-button-text="Добавить"
      :rowClassFunc="getRowClass"
      :isSmartPagination="false"
      data-qa="TmsTable"
      @select="onSelect"
      @add="onAdd"
      ref="obTableTms"
      is-fixed-header
    >
      <template v-slot:extraFuncToPanel>
        <div class="table-filters">
          <div class="table-filter">
            <span>Исполнитель: </span>
            <ob-inline-select
              v-model="filterContractor.uuid"
              :items="contractors"
            />
          </div>
          <div class="table-filter">
            <span>Статус: </span>
            <ob-inline-select
              v-model="filterStatus.uuid"
              :items="statuses"
            />
          </div>
        </div>
      </template>
      <template v-slot:status="{ data }">
        <span :class="data.item.status === 'ACTIVE' ? 'active' : ''">
          {{ $options.statusMap[data.item.status] }}
        </span>
      </template>

      <template v-slot:type="{ data }">
        {{ $options.typesMap[data.item.quotationType] }} 
      </template>

      <template v-slot:subperiod="{ data }">
        —
      </template>

      <template v-slot:startDate="{ data }">
        <span :class="isFutureDate(data.item.applyFromD) ? 'isFuture' : ''">
          {{new Date(data.item.applyFromD) | date}}
        </span>
      </template>

      <template v-slot:endDate="{ data }">
        {{new Date(data.item.applyToD) | date}}
      </template>

      <template v-slot:actions="{ data }">
        <ob-menu-dropdown
          :items="[{ title: 'Создать копию политики', icon: 'copy-2', method: () => onCopy(data) }, ...(data.item.status !== 'REMOVED' ?[{title: 'Удалить политику', icon: 'trash', method: () => confirmDelete(data)}] : [])]"
          trigger="click"
        >
        </ob-menu-dropdown>
      </template>

      <template slot="noneContent">
        <div class="no-content">
          <p>Здесь вы можете создавать политики распределения заказов</p>
          <span @click="onAdd">Создать политику</span>
        </div>
      </template>
    </ob-table>

    <ob-modal
      ref="removeRuleModal"
      size="medium"
      title="Удалить политику?"
      :is-show-controls="true"
      okText="Удалить"
      cancelText="Не удалять"
      isError
      @submit="removeRule"
    >
      <div class="stop-rule">
        <div class="stop-rule__row">
          Вы хотите безвозвратно удалить политику {{ activeRule.number }}?
        </div>
      </div>
    </ob-modal>
  </single-panel>
</template>

<script>
import api from '@/api';
import SinglePanel from "common-components/src/obComponents/obSinglePanels";
import ObTable from "common-components/src/obComponents/obTable";
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect';
import ObModal from "common-components/src/obComponents/obModal";

export default {
  name: 'tmsPage',
  components: {
    SinglePanel,
    ObTable,
    ObMenuDropdown,
    ObInlineSelect,
    ObModal
  },

  statusMap: {
    DRAFT: 'Черновик',
    ACTIVE: 'Действующая',
    STOPPED: 'Приостановлена',
    TERMINATED: 'Завершена',
    REMOVED: 'Удалена'
  },

  typesMap: {
    'VOLUME_ON_SUBPERIOD': 'Объём на подпериод',
    VOLUME: 'Объём за весь период',
    'VOLUME_SHARE': 'Процент от объёма'
  },

  data() {
    return {
      activeRule: '',
      contractors: [
        {
          title: 'Все',
          uuid: 'ALL'
        },
        {
          title: 'ООО "ОБОЗ ДИДЖИТАЛ"',
          uuid: '2'
        }
      ],

      filterContractor: {
        title: 'Все',
        uuid: 'ALL'
      },

      statuses: [
        {
          title: 'Все',
          uuid: 'ALL'
        },
        {
          title: 'Черновик',
          uuid: 'DRAFT'
        },
        {
          title: 'Действующая',
          uuid: 'ACTIVE' 
        },
        {
          title: 'Приостановлена',
          uuid: 'STOPPED'
        },
        {
          title: 'Завершена',
          uuid: 'TERMINATED'
        },
        {
          title: 'Удалена',
          uuid: 'REMOVED'
        }
      ],

      filterStatus: {
        title: 'Все',
        uuid: 'ALL'
      },

      tmsColumns: [
        {
          title: '№ Политики',
          key: 'number'
        },
        {
          title: 'статус',
          key: 'status',
          slotName: 'status'
        },
        {
          title: 'название',
          key: 'title'
        },
        {
          title: 'тип квотирования',
          key: 'quotationType',
          slotName: 'type'
        },
        {
          title: 'подпериод',
          key: 'subperiod',
          slotName: 'subperiod',
          sortDisable: true
        },
        {
          title: 'действует с',
          key: 'applyFromD',
          slotName: 'startDate'
        },
        {
          title: 'действует по',
          key: 'applyToD',
          slotName: 'endDate'
        },
        {
          title: '',
          slotName: 'actions',
          action: true,
          isToggleDisabled: true
        }
      ]
    }
  },

  methods: {
    async getTms({page, size, sort = "createdAt,desc", query}) {
      const altSort = sort?.split(',')
      try {
        const res = await api.tms.getTms({page, size, sort: altSort[0], direction: altSort[1].toUpperCase(), query});
        return res;
      } catch (err) {
        console.error(err);
      }
    },

    onSelect(item) {
      this.$router.push(`/tms/${item.uuid}`);
    },

    onCopy(data) {
      console.log('copy ->', data);
    },

    confirmDelete(item) {
      this.activeRule = item.item;
      this.$refs.removeRuleModal.open();
    },

    async removeRule() {
      try {
        await api.tms.changeStatus(this.activeRule.uuid, 'REMOVED');
        this.$refs.removeRuleModal.close();
        this.$refs.obTableTms.loadData({ init: true });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при совершении операции"
        });
      }
    },

    onAdd() {
      this.$router.push('/tms/new');
    },

    isFutureDate(date) {
      const today = new Date();
      return today < new Date(date);
    },

    getRowClass (data) {
      return data.item.status === 'REMOVED' ? '--removed' : ''
   }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.table-filters {
  display: flex;
  align-items: center;
  width: 100%;
}

.table-filter {
  background: $blue-150;
  border-radius: 19px;
  padding: 5px 9px;
  font-size: 14px;
  line-height: 18px;
  letter-spacing: 0.2px;
  color: $shale-gray;

  &:nth-child(1) {
    margin-right: 12px;
  }

  &:nth-child(2) {
    margin-right: 22px;
  }
}

.active {
  color: $deep-blue;
}

.isFuture {
  color: $color-grey-span;
}

.no-content {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  p {
    @include font-mixin(24px, 40px, 400, $color-grey-span);
  }

  span {
    margin-top: 20px;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
    text-decoration: none;
    cursor: pointer;
  }
}

::v-deep {
  th:last-child {
    pointer-events: none;
  }

  .ob-menu-dropdown-container .menu-dropdown-list__item button .col-left i.copy-2:before {
    color: $color-blue-navy-blue;
  }

  .ob-menu-dropdown-container .menu-dropdown-list__item button .col-left i.trash:before {
    color: $color-error;
  }

  .--removed td > .td-container {
    color: $color-grey-span
  }

  .ob-func-panel__controls-side:first-child span {
    color: $color-blue-smalt;
  }
  .ob-func-panel__controls-side:nth-child(2) {
    flex-grow: 1;
    justify-content: space-between;
  }

  .ob-inline-select__label {
    color: $color-text-base;
  }
}

</style>